// COPYRIGHT 

/*
 *
 *
 *
 *   EXEMPLE FILE TO CREATE COMMAND BASE : DO NOT WRITE IN
 *
 *   
 *
 *
 */

#ifndef KPP_COMMAND_LOADOBSTACLE_H
#define KPP_COMMAND_LOADOBSTACLE_H

/*****************************************
 INCLUDES
*******************************************/

#include <iostream>

#include "kppInterfaceWalk/kppInterfaceWalk.h"

#include "KineoModuleManager/kppModuleInterface.h"
#include "KineoGUI/kppGUIModuleInterface.h"
#include "KineoController/kppUICommand.h"

//#include "KineoController/kppCommand.h"
#include "KineoController/kppPlanPathCommand.h"

KIT_PREDEF_CLASS( CkppCommandLoadObstacle );


/*****************************************
 CLASS
*******************************************/

class CkppCommandLoadObstacle : public CkppPlanPathCommand
{

public:

  enum EParameters
    {
      PARAMETER_COUNT
    };

  static CkppCommandLoadObstacleShPtr   create(CkppInterfaceWalk *kpp);

  static CkppCommandLoadObstacleShPtr   createCopy(const CkppCommandLoadObstacleConstShPtr& i_command);

  virtual ~CkppCommandLoadObstacle();

  /**
     \brief : What function does.
  */
  virtual ktStatus doExecute();

  virtual bool	isUndoable() const;

  virtual CkppCommandShPtr clone() const;

  virtual unsigned int	countParameters() const;

  virtual CkppParameterConstShPtr	parameter(unsigned int i_rank) const;

protected:

  CkppCommandLoadObstacle(CkppInterfaceWalk *kpp);

  CkppCommandLoadObstacle(const CkppCommandLoadObstacle& i_command);

  ktStatus init(const CkppCommandLoadObstacleWkPtr& i_weakPtr);

private:

  CkppCommandLoadObstacleWkPtr m_weakPtr;

  /// pointer to the interface
  CkppInterfaceWalk *attKpp;

};

#endif
